/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import java.util.ArrayList;
import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.geom.Ellipse;
import org.newdawn.slick.geom.Vector2f;
import org.newdawn.slick.tiled.TiledMap;

// TODO this class is not very well writen. 
/**
 * This class loads and stores the information given in a .tmx file
 * created with the program Tiled ({@link http://www.mapeditor.org/ }).
 * <p>
 * At the moment, it checks the map for tiles with the id 1 and assumes
 * that they are not passable, so it creates a <code>Block</code> with
 * the tile size provided by the map.
 * It ignores all other tiles as decoration. Meaning they do not affect
 * game play but are printed to the screen.
 * Based on the objects described in the map it does initialize
 * the player (object id (in tiled map) 0),
 * the enemy (object id 1),
 * players banana (object id 2),
 * enemy banana (object id 3),
 * 
 * @see ICollidableObject
 *
 * @author sam
 */
public class BlockMap {

    private TiledMap tmap;
    //private int mapWidth;
    //private int mapHeight;
    private ArrayList<Object> entities;
    private Ape ape;
    private Ape enemy;
    private Banana banana;
    private Banana banana2;

    public BlockMap(String ref) throws SlickException {

        entities = new ArrayList<Object>();
        tmap = new TiledMap(ref, "data");

        //mapWidth = tmap.getWidth() * tmap.getTileWidth();
        //mapHeight = tmap.getHeight() * tmap.getTileHeight();

        // init player ape
        Ellipse apeEll = new Ellipse(tmap.getObjectWidth(0, 0) / 2, tmap.getObjectHeight(0, 0) / 2, tmap.getObjectWidth(0, 0) / 2, tmap.getObjectHeight(0, 0) / 2);
        Image img = new Image("/data/" + tmap.getObjectImage(0, 0));
        ape = new Ape(tmap.getObjectName(0, 0),
                img.getScaledCopy(tmap.getObjectWidth(0, 0), tmap.getObjectHeight(0, 0)),
                new Vector2f(tmap.getObjectX(0, 0), tmap.getObjectY(0, 0)),
                apeEll);

        // init enemy ape
        apeEll = new Ellipse(tmap.getObjectWidth(0, 1) / 2, tmap.getObjectHeight(0, 1) / 2, tmap.getObjectWidth(0, 1) / 2, tmap.getObjectHeight(0, 1) / 2);
        img = new Image("/data/" + tmap.getObjectImage(0, 1));
        enemy = new Ape(tmap.getObjectName(0, 1),
                img.getScaledCopy(tmap.getObjectWidth(0, 1), tmap.getObjectHeight(0, 1)),
                new Vector2f(tmap.getObjectX(0, 1), tmap.getObjectY(0, 1)),
                apeEll);

        // init banana
        apeEll = new Ellipse(tmap.getObjectWidth(0, 2) / 2, tmap.getObjectHeight(0, 2) / 2, tmap.getObjectWidth(0, 2) / 2, tmap.getObjectHeight(0, 2) / 2);
        img = new Image("/data/" + tmap.getObjectImage(0, 2));
        banana = new Banana(tmap.getObjectName(0, 2),
                img.getScaledCopy(tmap.getObjectWidth(0, 2), tmap.getObjectHeight(0, 2)),
                new Vector2f(tmap.getObjectX(0, 2), tmap.getObjectY(0, 2)),
                apeEll);

        apeEll = new Ellipse(tmap.getObjectWidth(0, 3) / 2, tmap.getObjectHeight(0, 3) / 2, tmap.getObjectWidth(0, 3) / 2, tmap.getObjectHeight(0, 3) / 2);
        img = new Image("/data/" + tmap.getObjectImage(0, 3));
        banana2 = new Banana(tmap.getObjectName(0, 3),
                img.getScaledCopy(tmap.getObjectWidth(0, 3), tmap.getObjectHeight(0, 3)),
                new Vector2f(tmap.getObjectX(0, 3), tmap.getObjectY(0, 3)),
                apeEll);

        // init collision blocks
        int tileHeight = tmap.getTileHeight();
        int tileWidth = tmap.getTileWidth();
        for (int x = 0; x < tmap.getWidth(); x++) {
            for (int y = 0; y < tmap.getHeight(); y++) {
                int tileID = tmap.getTileId(x, y, 0);
                if (tileID == 1) {
                    entities.add(
                            new Block(x * tileHeight, y * tileWidth, tileWidth, tileHeight));
                }
            }
        }
    }

    public Ape getApe() {
        return ape;
    }

    public Banana getBanana() {
        return banana;
    }

    public Banana getBanana2() {
        return banana2;
    }

    public Ape getEnemy() {
        return enemy;
    }

    public ArrayList<Object> getEntities() {
        return entities;
    }

    public TiledMap getTmap() {
        return tmap;
    }

    
}