/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import java.util.ArrayList;
import org.newdawn.slick.geom.Vector2f;

/**
 *
 * @author sam
 */
public class EnemyAIMediumRewrite extends AbstractEnemyAI implements IEnemyAI {

    /** infos about previous throw. */
    private boolean collision; // did a collision occure?
    private boolean canGoOver; // if a collision occured, is it possible to avoid it by throwing the object over the collision form?
    private boolean canGoUnder; // if a collision occured, is it possible to avoid it by throwing the object under the collision form?
    private float previousBeta;
    private float previousVelocity;
    private float incidentAngle; // the angle to the x axis of the collision

    /** values for next throw. */
    private float nextBeta;
    private float nextVelocity;

    public EnemyAIMediumRewrite(BlockMap map) {
        super(map);
    }

    @Override
    public void calculateVelocityBeta() {
        setValuesForPrevious();
        if (!collision) {
             /*Vector2f positionBeforeSpawn = super.map.getBanana2().getPositionBeforSpawn();
            if (positionBeforeSpawn.x < super.map.getApe().getCollisionShape().getCenterX()) { //throw went too far

            } else if (positionBeforeSpawn.x > super.map.getApe().getCollisionShape().getCenterX()) { // throw went not far enough

            } else {
                // TODO case that x value is correct, but y value is not (eg. enemy sits on high platform
            }*/
        } else if (!canGoOver) {
            // lower max beta
        } else if (!canGoUnder) {
            // depends on incidentAngle. either raise or lower beta
        }
    }

    @Override
    public float getBeta() {
        return nextBeta;
    }

    @Override
    public float getVelocity() {
        return nextVelocity;
    }

    private void setValuesForPrevious() {
        Vector2f positionBeforeSpawn = super.map.getBanana2().getPositionBeforSpawn();
        if (positionBeforeSpawn.x >= gc.getScreenWidth() || positionBeforeSpawn.x <= 0 || positionBeforeSpawn.y >= gc.getScreenHeight()) {
            collision = false; // went ouside screen left, right or bottom -> no collision
        } else if (landedOnLowestCollisionForm()) { // landed on a collision field, but there are no lower non-collision fields -> no (relevant) collision
            collision = false;
        } else {
            collision = true; // stoped moving somewhere in the middle -> collision
        }
        // TODO set values for canGoOver / canGoUnder
    }

    private boolean landedOnLowestCollisionForm() {
        return true;
    }
}
