/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.ScalableGame;

/**
 * The main class of the game "Apes throw bananas".
 *
 * @author sam
 */

public class Game extends StateBasedGame {

    public static final int MAINMENUSTAT = 0;
    public static final int GAMEPLAYSTATE = 1;
    public static final int INTROSTATE = -1;

    public static AppGameContainer app;

    public Game() {
        super("Apes throw Bananas!");
        this.addState(new IntroState(INTROSTATE));
        this.addState(new MainMenuState(MAINMENUSTAT));
        this.addState(new GameState(GAMEPLAYSTATE, "/data/lvl1.tmx"));
        // debug
        if (Settings.SKIPINTRO) {
            this.enterState(GAMEPLAYSTATE);
        } else {
            this.enterState(INTROSTATE);
        }

    }

    @Override
    public void initStatesList(GameContainer gameContainer) throws SlickException {
    }

    public static void main(String[] args) throws SlickException {
        app = new AppGameContainer(new ScalableGame(new Game(), Settings.DISPLAYWIDTH, Settings.DISPLAYHIGTH, Settings.FULLSCREEN));
        try {
            if (Settings.DEBUG) {
                app.setDisplayMode(800, 600, false);

            } else {
                app.setDisplayMode(Settings.DISPLAYWIDTH, Settings.DISPLAYHIGTH, Settings.FULLSCREEN);
            }
            app.setVSync(false);
            app.start();
        } catch (Exception e) {
            System.out.println("could not set " + Settings.DISPLAYWIDTH + "x" + Settings.DISPLAYHIGTH + "\ntrying desktop display mode (may be distorted)");
            DisplayMode desktopDisplayMode = Display.getDesktopDisplayMode();
            app.setDisplayMode(desktopDisplayMode.getWidth(), desktopDisplayMode.getHeight(), true);
            app.start();
            app.setVSync(false);
        }
        /*
        DisplayMode[] availableDisplayModes;
        try {
            availableDisplayModes = Display.getAvailableDisplayModes();
        for (int i = 0; i < availableDisplayModes.length; i++) {
            DisplayMode displayMode = availableDisplayModes[i];
            System.out.println(displayMode.getHeight() + "x" + displayMode.getWidth() + ": " + displayMode.isFullscreenCapable());
        }
        } catch (LWJGLException ex) {
            Logger.getLogger(Game.class.getName()).log(Level.SEVERE, null, ex);
        }*/
    }
}
