/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import org.newdawn.slick.geom.Shape;

/**
 * An interface for an object that can collide with other <code>ICollidableObject</code>s.
 *
 * @author sam
 */
public interface ICollidableObject {

    /**
     * returns the general collision shape of this object.
     *
     * @return
     */
    public Shape getNormalCollisionShape();

    /**
     * returns the collision shape of this object moved to its actual position.
     *
     * @return
     */
    public Shape getCollisionShape();

    /**
     * checks weather or not this object is colliding with the provided object.
     *
     * @param collidable
     * @return
     */
    public boolean isCollidingWith(ICollidableObject collidable);
}