/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import java.util.LinkedList;

/**
 *
 * @author sam
 */
public class EnemyAIChooser {
    
    private LinkedList<IEnemyAI> ais;

    public EnemyAIChooser(BlockMap map) {
        ais = new LinkedList<IEnemyAI>();
        ais.add(new EnemyAISimple(map));
        ais.add(new EnemyAIMediumBACKUP(map));
        ais.add(new EnemyAIMedium(map));
        ais.add(new EnemyAIMediumRewrite(map));
    }

    public IEnemyAI getAI() {
        return ais.get(Settings.AItoUse);
    }
}
