/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;


/**
 * this simple ai throws bananas at a random velocity and angle.
 * The velocity and angle are restricted by the values defined in IEnemyAI.
 *
 * @author sam
 */
public class EnemyAISimple extends AbstractEnemyAI implements IEnemyAI {

    private float beta;
    private float velocity;

    public EnemyAISimple(BlockMap map) {
        super(map);
        super.MINTHINKINGTIME = 300;
        super.MAXTHINKINGTIME = 600;
    }

    @Override
    public void calculateVelocityBeta() {
        calculateBeta();
        calculateVelocity();
    }

    @Override
    public float getBeta() {
        return beta;
    }

    @Override
    public float getVelocity() {
        return velocity;
    }


    public void calculateBeta() {
        beta = (float) Math.toRadians(randomBetween((int) MINBETA, (int) MAXBETA));
    }

    public void calculateVelocity() {
        velocity = randomBetween((int) MINVELOCITY, (int) MAXVELOCITY);
    }
}
