/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

/**
 *
 * @author sam
 */
public class SettingsLevel {

    private boolean[] isLevelOpen = new boolean[9];

    public SettingsLevel() {
        isLevelOpen[0] = true;
    }    

    public boolean isLevelOpen(int i) {
        if (Settings.DEBUG) {
            return true;
        }
        if (i > 0 && i <= getNumberOfLevels()) {
            return isLevelOpen[i - 1];
        }
        return false;
    }

    /**
     * opens the given level.
     * If i is bigger than one nothing happens (you cannot open a negativ level
     * and level one is always open). If it is bigger that the number of levels
     * it will do nothing as well.
     *
     * @param i
     */
    public void openLevel(int i) {
        if (i > 1 && i <= getNumberOfLevels()) {
            isLevelOpen[i - 1] = true;
        }
    }

    public int getNumberOfLevels() {
        return isLevelOpen.length;
    }
}
